/**
 * 
 */
package jagafa.ai.core;

import jagafa.JassRound;
import jagafa.object.Card;
import jagafa.object.Player;
import jagafa.rule.RuleSet;

/**
 * General interface defining the functions available to the game for computing 
 * cards by AI
 */
public interface JassAI {
	/**
	 * Compute a card to be played by the player
	 * @return The card computed by the AI
	 */
	public abstract Card computeCard();
	
	/**
	 * Initializes the AI with the Player and the Game object
	 * @param p The player which holds this AI
	 * @param game The game object
	 */
	public abstract void init(Player p,JassRound game);
	
	/**
	 * Choose a RuleSet out of the available Sets of a given scoreTable 
	 * 
	 */
	public abstract RuleSet chooseRuleSet();
	
}
