/**
 * 
 */
package jagafa.naming;

import jagafa.object.Card;

/**
 * CardNames is a utility class for constructing user-friendly readable 
 * string-representations of cards
 */
public abstract class CardNames {

	/**
	 * Get a user-friendly name of the card
	 * @param c The card
	 * @return A string containing the color and value name of the card
	 */
	public static String getName(Card c){
		if (c == null){
			return null;
		}
		int color = c.getColor();
		int value = c.getValue();
		
		String colorName = ESwissColorNames.getName(color);
		String valueName = ESwissValueNames.getName(value);
		
	
		return colorName.toUpperCase() +""+ valueName.toUpperCase();	
	}
	
}
