/*
 * Created on 24.02.2005 Filename: Board.java
 */
package jagafa.object;

import java.util.LinkedList;
import java.util.List;

/**
 * The Board object holds alls the cards played including the information
 * which Player played which Card (Is also a CardList)
 */
public class Board extends CardList {
	private List<Player> players_;

	/**
	 * Constructor: Init the board and init playerList
	 */
	public Board() {
		super();
		players_ = new LinkedList<Player>();

	}

	/**
	 * Copy Constructor: Init the board and init playerList
	 * @param b The board to copy
	 */
	public Board(Board b) {
		players_ = new LinkedList<Player>();
		for (int i = 0; i < b.size(); i++) {
			this.addCard(b.get(i).copy(), b.getPlayerOfPos(i));
		}

	}

	/**
	 * Adds a Card to the Board
	 * @param c The card to add
	 * @param p The player which played the card
	 */
	public void addCard(Card c, Player p) {
		if (this.cardsPlayed() == 4) {
			this.clearBoard();

		}
		super.add(c);
		this.players_.add(p);
		
	}

	/**
	 * Clear the PlayerList
	 */
	private void clearPlayers() {
		players_ = new LinkedList<Player>();
	}

	/**
	 * Clear the Board
	 */
	public void clearBoard() {
		clearPlayers();
		this.clear();
		//System.out.println("----------------------------------------");
	}

	/**
	 * Get the number of cards on the board
	 * @return The number of Cards played
	 */
	public int cardsPlayed() {
		return super.size();
	}

	/**
	 * Get the Player who played the n-th card
	 * @return The Player who played the n-th card
	 * @param pos The position of the card
	 */
	public Player getPlayerOfPos(int pos) {
		if (players_.size() <= pos)
			return null;
		return this.players_.get(pos);
	}

	/**
	 * Get the color of the first card played
	 * @return The color of the first card on the Board
	 */
	public int getFirstColor() {
		return this.get(0).getColor();
	}

	/**
	 * Get the first card played
	 * @return The first card on the Board
	 */
	public Card getFirstCard() {
		return this.get(0);
	}
}