package jagafa.object;

import jagafa.naming.CardNames;

/**
 * Klasse Card: Enthlt eine Karte mit Farbe und Kartenwert
 */
public class Card {
	/**
	 * Enthlt Farbe und Wert der Karte internal representation; integer
	 * values!!!
	 */
	private int color_;

	private int value_;

	/**
	 * Erstellt ein neues Kartenobjekt
	 * @param color The color
	 * @param value The value
	 */
	public Card(int color, int value) {
		color_ = color;
		value_ = value;
	}

	/**
	 * Setzt die Farbe der Karte
	 * @param color The new value
	 */
	public void setColor(int color) {
		color_ = color;
	}

	public boolean equals(Card o) {
		if (o.getColor() == (getColor()) && o.getValue() == (getValue())) {
			return true;
		}
		return false;
	}

	/**
	 * Setzt den Wert der Karte
	 * @param value The new value
	 */
	public void setValue(int value) {
		value_ = value;
	}

	/**
	 * Get the value of the card
	 * @return The value
	 */
	public int getValue() {
		return value_;
	}

	/**
	 * Get the color of the card
	 * @return The color
	 */
	public int getColor() {
		return color_;
	}

	/**
	 * Get a exact copy of the card
	 * @return A copy of the card
	 */
	public Card copy() {
		return new Card(getColor(), getValue());
	}

	/**
	 * Liefert einen String mit Farbe und Wert der Karte
	 * @return A String with the print-friendly name of the card
	 */
	public String toString() {
		return CardNames.getName(this);
	}

	
	public int hashCode() {
		int sum = 0;
		sum += this.color_;
		sum += this.value_;

		return sum;
	}
	
	
	
}