/**
 * 
 */
package jagafa.object;

import java.util.LinkedList;
import java.util.List;

/**
 * Distrubutor shuffles the cards and distributes them to a list of Players
 * Abstract helper class (cannot be instantiated)
 */
public abstract class Distributor {
	private static final int HAND_SIZE = 9;
	private static final int COLORS = 4;
	private static List<Card> cardList_;

	/**
	 * Distrubute the Cards to the Players in the List given
	 * @param playerList The List of Players (java.util.list)
	 * 
	 */
	public static void distributeCardsTo(List<Player> playerList) {
		cardList_ = new LinkedList<Card>();
		createCardList();

		for (int i = 0; i < COLORS; i++) {
			Player p = playerList.get(i);
			for (int j = 0; j < HAND_SIZE; j++) {
				// p.getHand().add(cardList_.get(i*9+j));
				int random = (int) ((Math.random()) * cardList_.size());
				p.getHand().add(cardList_.get(j+i*HAND_SIZE));
				//cardList_.remove(random);
			}
		}
	}

	/**
	 * Create the cards and shuffle them
	 */
	private static void createCardList() {
		cardList_ = new LinkedList<Card>();
		for (int i = 0; i < COLORS * HAND_SIZE; i++) {
			cardList_.add(null);
		}

		for (int i = 0; i < COLORS; i++) {
			for (int j = 0; j < HAND_SIZE; j++) {
				Card c = new Card(i, j);
				int random = (int) ((Math.random()) * COLORS * HAND_SIZE);
				while (cardList_.get(random) != null) {
					random = (int) (Math.random() * COLORS * HAND_SIZE);
				}
				cardList_.set(random, c);
			}
		}

	}
}
