package jagafa.scores;

import jagafa.rule.ObenRules;
import jagafa.rule.RuleSet;
import jagafa.rule.TrumpfRules;
import jagafa.rule.UntenRules;

import java.util.Iterator;
import java.util.Map;
import java.util.TreeMap;
/**
 * @deprecated
 */
public class CoiffeurScoreTable extends AbstractScoreTable implements ScoreTable {

	private int winningScore_;

	private Map<RuleSet, Integer> ruleList_;

	
	public CoiffeurScoreTable(int winningScore) {
		super();
		this.winningScore_ = winningScore;
		 ruleList_ = new TreeMap<RuleSet, Integer>();
		
		ruleList_.put(new TrumpfRules(0), 1);
		ruleList_.put(new TrumpfRules(1), 2);
		ruleList_.put(new TrumpfRules(2), 3);
		ruleList_.put(new TrumpfRules(3), 4);
		ruleList_.put(new ObenRules(), 5);
		ruleList_.put(new UntenRules(), 6);
		
		Iterator<RuleSet> ruleIter = ruleList_.keySet().iterator();

		while (ruleIter.hasNext()) {
			this.activateRule(ruleIter.next());
		}
	}

	
	
	@Override
	public void addScores(int[] scores, RuleSet rules) {
		int mult = this.getMultiplier(rules);
		
		for (int i = 0;i<scores.length;i++) {
			scores[i] *= mult;
		}
		super.addScores(scores, rules);
		
	}



	public boolean isGameOver() {
		int scores[] = this.getScores();

		int scoreTeam1 = scores[0] + scores[2];
		int scoreTeam2 = scores[1] + scores[3];

		if (scoreTeam1 >= this.winningScore_) {
			return true;
		}
		if (scoreTeam2 >= this.winningScore_) {
			return true;
		}
		return false;
	}

	public int getMultiplier(RuleSet rule) {
		return (Integer)this.ruleList_.get(rule);
	}



	public boolean changeChoosingPlayer() {
		return false;
		
	}



	public int getChoosingPlayer() {
		// TODO Auto-generated method stub
		return -1;
	}



	


	public int getWinningScore() {
		return 0;
	}

	
	
	

}
