/**
 * 
 */
package jagafa.stats;

import jagafa.JassRound;
import jagafa.object.CardList;
import jagafa.object.Hand;

import javax.swing.JComponent;

/**
 * GameStats takes a Game object and collects some statistics about it
 * Mainly from the view of the active Player!
 * 
 */
public class RoundStats {
	private static final int COLORS = 4;

	private int scoreTeam1_;

	private int scoreTeam2_;

	private CardList goneList_[];

	private JassRound round_;

	public RoundStats(JassRound round) {
		this.round_ = round;

		this.update();
	}

	/**
	 * Update the stats
	 */
	public void update() {
		this.createGoneStats();
		this.createScoreStats();
	}

	/**
	 * Create two int variables with the teams scores
	 */
	private void createScoreStats() {
		int sum1 = round_.getPlayer(0).getScore() + round_.getPlayer(2).getScore();
		int sum2 = round_.getPlayer(1).getScore() + round_.getPlayer(3).getScore();
		scoreTeam1_ = sum1;
		scoreTeam2_ = sum2;
	}

	private void createGoneStats() {
		this.goneList_ = new CardList[COLORS];
		for (int i = 0; i < COLORS; i++) {
			this.goneList_[i] = new CardList();
			CardList goneofcol = round_.getGoneHeap().getGoneOfColor(i);
			Hand h = new Hand(goneofcol);
			h.sort(this.round_.getRules());
			goneList_[i].addAll(h);
		}
	}

	/**
	 * @return Returns the goneList in the form CardList[color].
	 */
	public CardList[] getGoneList() {
		return this.goneList_;
	}

	/**
	 * @return Returns the scoreTeam1.
	 */
	public int getScoreTeam1() {
		return this.scoreTeam1_;
	}

	/**
	 * @return Returns the scoreTeam2.
	 */
	public int getScoreTeam2() {
		return this.scoreTeam2_;
	}

	public int turnsPlayed() {
		return this.round_.getGoneHeap().turns();
	}
	
	public void setRound(JassRound round) {
		this.round_ = round;
	}

	public JComponent getView() {

		return null;
	}
}
