/*
 * Created on 21.06.2005 Filename: HeapSort.java
 */
package jagafa.util;


import java.util.Comparator;
import java.util.Iterator;
import java.util.List;

/**
 * Sorts a list in descending order (highest first). Names can be associated to
 * the input list. These names will be sorted simultaneously
 * 
 * @param <VAL_TYPE>
 */
public class InsertSort<VAL_TYPE, NAME_TYPE> {
	private Comparator<VAL_TYPE> comparator = new Comparator<VAL_TYPE>() {

		@SuppressWarnings("unchecked")
		public int compare(VAL_TYPE o1, VAL_TYPE o2) {
			return ((Comparable<VAL_TYPE>) o1).compareTo(o2);
		}
	};

	private List<VAL_TYPE> list_;

	private List<NAME_TYPE> names_;

	private Heap<NAME_TYPE> newNameList_;

	public InsertSort(List<VAL_TYPE> l, List<NAME_TYPE> names) {
		list_ = l;

		this.names_ = names;
		this.newNameList_ = new Heap<NAME_TYPE>();
	}

	public List<VAL_TYPE> sort(List<VAL_TYPE> l) {
		this.list_ = l;

		Class<? extends Object> type = list_.get(0).getClass();
		if (Comparable.class.isAssignableFrom(type)) {

		} else {
			return null;
		}

		Heap<NAME_TYPE> newNames = new Heap<NAME_TYPE>();
		Heap<VAL_TYPE> newList = new Heap<VAL_TYPE>();
		Iterator<VAL_TYPE> iter = list_.iterator();
		Iterator<NAME_TYPE> nameIter = names_.iterator();

		VAL_TYPE last = iter.next();
		newList.insertFirst(last);
		newNames.insertFirst(nameIter.next());
		while (iter.hasNext()) {
			VAL_TYPE next = iter.next();

			boolean ok = false;
			for (int i = 0; i < newList.size(); i++) {
				VAL_TYPE ss = newList.get(i);
				if (comparator.compare(next, ss) > 0) {
					newList.insert(i, next);
					if (nameIter.hasNext()) {
						newNames.insert(i, nameIter.next());
					}
					ok = true;
					break;
				}
			}

			if (!ok) {

				if (comparator.compare(next, last) < 0) {
					newList.insertLast(next);
					if (nameIter.hasNext()) {
						newNames.insertLast(nameIter.next());
					}
				} else {
					newList.insertFirst(next);
					if (nameIter.hasNext()) {
						newNames.insertFirst(nameIter.next());
					}
				}
			}

			last = newList.get(0);

		}
		
		this.newNameList_ = newNames;

		return newList;
	}

	public List<NAME_TYPE> getNameList() {
		return this.newNameList_;
	}
}
