package jagafa.util.dump;

import jagafa.flags.TestingFlags;

import java.io.PrintStream;

import javax.swing.JPanel;



public class Dump {

	private static DumpPanel dumpPanel_;

	private static SystemOutRepoStream stream_;

	public Dump() {
		dumpPanel_ = new DumpPanel();

		stream_ = new SystemOutRepoStream();

		if (TestingFlags.redirectSystemOut_) {
			System.setOut(stream_);
			System.out.println("Retrieving System.out output...");
			System.out.println("------------------------------------------------------");
		}
	}

	public static JPanel getDumpPanel() {
		return dumpPanel_;
	}

	private class SystemOutRepoStream extends PrintStream {

		public SystemOutRepoStream() {
			super(System.out);
		}

		@Override
		public void println(String arg0) {
			dumpPanel_.dump(arg0 + "\n");

		}

		@Override
		public void println(Object arg0) {
			dumpPanel_.dump(arg0.toString() + "\n");

		}

		@Override
		public void println() {
			dumpPanel_.dump("\n");

		}

		@Override
		public void print(Object arg0) {
			dumpPanel_.dump(arg0.toString());

		}

		@Override
		public void print(String arg0) {
			dumpPanel_.dump(arg0);

		}

	}

	public static void clear() {
		dumpPanel_.clear();
	}
	
	

}
