package jagafa.util.dump;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.border.Border;

public class DumpPanel extends JPanel implements ActionListener {
	/**
	 * 
	 */
	private static final long serialVersionUID = -9071344325150010684L;

	private static final String CLEAR_DUMP = "Clear";

	private JTextArea textArea_;

	public DumpPanel() {
		super();
		this.addTitleBorder("Dump");
		this.setLayout(new BorderLayout());
		textArea_ = new JTextArea();
		JButton clearButton = new JButton(CLEAR_DUMP);
		this.add(clearButton, BorderLayout.SOUTH);
		clearButton.addActionListener(this);

		JScrollPane scroll = new JScrollPane(textArea_);
		scroll.setAutoscrolls(true);

		this.add(scroll, BorderLayout.CENTER);
		//textArea_.requestFocus();

	}

	public void dump(String text) {
		//this.requestFocus();
		this.textArea_.append(text);

	}

	public void actionPerformed(ActionEvent arg0) {
		String command = arg0.getActionCommand();

		if (command.equals(CLEAR_DUMP)) {
			clear();
		}

	}

	public void clear() {
		this.textArea_.setText("");
	}

	private void addTitleBorder(String string) {
		Border b = BorderFactory.createLineBorder(Color.BLACK);

		Border titleB = BorderFactory.createTitledBorder(b, string);
		this.setBorder(titleB);

	}

}
