package jagafa.util.view;

import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.JComponent;
import javax.swing.JDialog;
import javax.swing.JOptionPane;
import javax.swing.JTextArea;
import javax.swing.Timer;
import javax.swing.border.Border;

public class TimedDialog implements ActionListener {
	private static int instances_ = 0;

	/**
	 * 
	 */
	private static final long serialVersionUID = -7904960637010006214L;

	private JDialog dialog;

	private Timer closeTimer_;

	private int delay_;

	private JComponent parent_;

	public TimedDialog(String message) {
		super();
		this.parent_ = null;
		this.delay_ = 1900;
		showDialog(message, parent_);

	}

	public TimedDialog(String message, JComponent parent) {
		super();
		this.parent_ = parent;
		this.delay_ = 1900;
		showDialog(message, parent);

	}

	public TimedDialog(String message, JComponent parent, int delay) {
		super();
		this.parent_ = parent;

		this.delay_ = delay;
		showDialog(message, parent);
	}

	JTextArea label;

	private void showDialog(String message, JComponent parent) {
		parent.validate();
		//	this.setUndecorated(true);
		//label = new JTextArea();
		//label.setText(message);
		//this.setContentPane(parent);
		//this.setIconImage(JOptionPane.);
		//this.setAlwaysOnTop(true);
		//this.setResizable(false);

		//this.setFocusable(false);
		//label.setEditable(false);
		//label.setForeground(Color.BLACK);
		//this.getContentPane().add(label);
		//this.setTitle("Hint");
		//JOptionPane.showInternalMessageDialog(parent_, message);
		//System.out.println(parent);
		dialog = new JOptionPane(message, 1).createDialog(parent, "HINT");
		dialog.setModal(false);
		dialog.setAlwaysOnTop(true);

		dialog.setFocusable(true);
		
		dialog.setEnabled(true);
		// dialog.setUndecorated(true);
		//dialog.setAlwaysOnTop(true);

		if (parent == null) {
			dialog.setLocation(100, 200 + instances_ * dialog.getHeight());
		} else {
			int xLocation = parent.getX() + dialog.getWidth() / 2;
			int yLocation = 150 + instances_ * dialog.getHeight();
			dialog.setLocation(xLocation, yLocation);
		}
	
		dialog.getContentPane().setBackground(Color.RED);
		dialog.setVisible(true);
		//this.pack();
		/*
		 if (parent == null) {
		 this.setLocation(0, 400 + instances_ * this.getHeight());
		 } else {
		 int xLocation = parent.getX();// + this.getWidth() / 2;
		 int yLocation = 400 + instances_ * this.getHeight();
		 //this.setLocation(xLocation, yLocation);
		 }*/
		instances_++;
		//	this.setVisible(true);
		installTimer();
		/*		dialog.setVisible(true);
		 dialog.setEnabled(false);
		 */
		//dialog.requestFocus();
	}

	private void installTimer() {
		this.closeTimer_ = new Timer(this.delay_, this);
		this.closeTimer_.setRepeats(false);
		this.closeTimer_.start();
	}

	public void actionPerformed(ActionEvent arg0) {

		//this.setVisible(false);
		dialog.dispose();
		//this.dispose();

		instances_--;
	}
	
	private void addTitleBorder(String string) {
		Border b = BorderFactory.createLineBorder(Color.BLACK);

		Border titleB = BorderFactory.createTitledBorder(b, string);
		

	}

}
