package jagafa.view.newui;

import java.awt.Color;

import jagafa.scores.ScoreTable;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSeparator;
import javax.swing.border.Border;

public class SimpleSTPanel extends JPanel {

	private static final long serialVersionUID = 184472838175055582L;

	private ScoreTable scoreTable_;

	public SimpleSTPanel(ScoreTable scoreTable) {
		this.scoreTable_ = scoreTable;
		this.setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
		create();
	}

	private JLabel roundsLabel;

	private JLabel team1Label;

	private JLabel team2Label;

    private JLabel winnerLabel;

	public void create() {
		this.removeAll();
		this.addTitleBorder("Score Table:");
		
		int scores[] = this.scoreTable_.getScores();

		int team1 = scores[0] + scores[2];
		int team2 = scores[1] + scores[3];
		roundsLabel = new JLabel("Rounds:        \t" + this.scoreTable_.roundsPlayed());
		team1Label = new JLabel( "Team1:         \t" + team1);
		team2Label = new JLabel( "Team2:         \t" + team2);
		winnerLabel = new JLabel("Winner:        \t" + this.scoreTable_.getWinningScore());
		this.add(roundsLabel);
		this.add(new JSeparator());
		this.add(team1Label);
		this.add(team2Label);
		this.add(new JSeparator());
		this.add(winnerLabel);

		this.validate();
	}
	boolean over = false;
	public void update() {

		int scores[] = this.scoreTable_.getScores();

		int team1 = scores[0] + scores[2];
		int team2 = scores[1] + scores[3];

		if (this.scoreTable_.isGameOver()) {
			winnerLabel.setText("GAME OVER!");
			if (!over) {
				roundsLabel.setText("Rounds:        \t" + this.scoreTable_.roundsPlayed());
				team1Label.setText( "Team1:         \t" + team1);
				team2Label.setText( "Team2:         \t" + team2);
			}
			over = true;
			this.validate();
			return;
		} else {
			winnerLabel.setText(     "Winner:       \t" + this.scoreTable_.getWinningScore());

		}
		roundsLabel.setText("Rounds:        \t" + this.scoreTable_.roundsPlayed());
		team1Label.setText( "Team1:         \t" + team1);
		team2Label.setText( "Team2:         \t" + team2);

		this.validate();

	}
	
	private void addTitleBorder(String title) {
		Border rawBorder = BorderFactory.createLineBorder(Color.BLACK);

		Border titledB = BorderFactory.createTitledBorder(rawBorder, title);
		this.setBorder(titledB);

	}

}
