package jagafa.view.newui;

import jagafa.flags.TestingFlags;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.GridLayout;

import javax.swing.BorderFactory;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JSeparator;
import javax.swing.JToggleButton;
import javax.swing.border.Border;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

public class TestingFlagsPanel extends JPanel implements ChangeListener {

	private static final String PAUSED = "Paused";

	private static final String REPEAT = "Always repeat";

	private static final String SHOWALLHANDS = "Show selected hands";

	/**
	 * 
	 */
	private static final long serialVersionUID = 543269931763256098L;

	private static final String DUMP = "Show Dump Flags";

	private static final String SPEEDUP = "Speedup";

	public TestingFlagsPanel() {
		
		this.addTitleBorder("Testing-Flag Control");
		this.setLayout(new BorderLayout());
		JToggleButton pauseItem = new JToggleButton(PAUSED);
		this.add(pauseItem);
		pauseItem.setSelected(TestingFlags.paused_);
		pauseItem.addChangeListener(this);
		
	
		
	
		JSeparator sep = new JSeparator();
		
		
	//	this.getContentPane().setBackground(new Color(0,0,0,0));
	//	this.getContentPane().setForeground(new Color(200,200,0,0));
		
	
		JToggleButton allHandsItem = new JToggleButton(SHOWALLHANDS);
		this.add(allHandsItem);
		allHandsItem.setSelected(TestingFlags.showAllHands_);
		allHandsItem.addChangeListener(this);
		
		
		
		JToggleButton allDumpItem = new JToggleButton(DUMP);
		this.add(allDumpItem);
		allDumpItem.addChangeListener(this);

		
		JToggleButton endlessItem = new JToggleButton(REPEAT);
		this.add(endlessItem);
		endlessItem.setSelected(TestingFlags.repeatedTest_);
		endlessItem.addChangeListener(this);
		
		
		JToggleButton speedupItem = new JToggleButton(SPEEDUP);
		this.add(speedupItem);
		speedupItem.setSelected(TestingFlags.speedUp_);
		speedupItem.addChangeListener(this);
		
		
		
		//this.setVisible(true);
		
		this.setLocation(0, 259);

		

		this.setLayout(new GridLayout(6, 1));
		
		//this.pack();
		//this.setResizable(false);
		this.setSize(140, this.getHeight());
		//this.setSize(140, 140);
		
		dumpFrame_ = new DumpFrame();
		dumpFrame_.setLocationRelativeTo(allDumpItem);
		dumpFrame_.setLocation(dumpFrame_.getX()+allDumpItem.getWidth()/2+dumpFrame_.getWidth()/2,dumpFrame_.getY()+allDumpItem.getHeight()/2);
		//dumpFrame_.setLocation(this.getLocation().x,this.getLocation().y);
	
		showHandFrame_ = new HandChoiceFrame();
		//dumpFrame_.setLocation(this.getLocation().x,this.getLocation().y);
		
	}

	private DumpFrame dumpFrame_;

	private HandChoiceFrame showHandFrame_;
	
	public void stateChanged(ChangeEvent arg0) {
		
		JToggleButton src = (JToggleButton) arg0.getSource();
		String name = src.getText();

		if (name.equals(PAUSED)) {
			TestingFlags.paused_ = src.isSelected();
		}
		if (name.equals(SHOWALLHANDS)) {
			//TestingFlags.showAllHands_ = src.isSelected();
			if (src.isSelected() != showHandFrame_.isVisible()) {
				showHandFrame_.setVisible(src.isSelected());
				showHandFrame_.setLocationRelativeTo(src);
				showHandFrame_.setLocation(showHandFrame_.getX()+src.getWidth()/2+showHandFrame_.getWidth()/2,showHandFrame_.getY()+src.getHeight()/2);
				
			}
		}

		if (name.equals(DUMP)) {
			if (src.isSelected() != dumpFrame_.isVisible()) {
				dumpFrame_.setVisible(src.isSelected());
				dumpFrame_.setLocationRelativeTo(src);
				dumpFrame_.setLocation(dumpFrame_.getX()+src.getWidth()/2+dumpFrame_.getWidth()/2,dumpFrame_.getY()+src.getHeight()/2);
			}
			
		}

		if (name.equals(REPEAT)) {
			TestingFlags.repeatedTest_ = src.isSelected();
		}
		if (name.equals(SPEEDUP)) {
			TestingFlags.speedUp_ = src.isSelected();
		}

	}

	private class HandChoiceFrame extends JFrame implements ChangeListener {

		/**
		 * 
		 */
		private static final long serialVersionUID = 7664901490669192679L;

		public HandChoiceFrame() {
			this.setTitle("Show Hand Flags");
			this.setLayout(new GridLayout(4, 1));
			
			for (int i = 0;i<4;i++) {
				JToggleButton pAIDump = new JToggleButton("Player " + i);
				this.getContentPane().add(pAIDump);
				pAIDump.setSelected(TestingFlags.showHand_[i]);
				pAIDump.addChangeListener(this);
			}
			
			
			this.setUndecorated(true);
			this.pack();
			this.setResizable(false);
			this.setAlwaysOnTop(true);
			
		}

		public void stateChanged(ChangeEvent arg0) {
			JToggleButton src = (JToggleButton) arg0.getSource();
			String name = src.getText();

			for (int i = 0;i<4;i++) {
				if (name.endsWith(String.valueOf(i))) {
					TestingFlags.showHand_[i] = src.isSelected();
					break;
				}
			}
			
		}
	}
	
	
	
	
	
	private class DumpFrame extends JFrame implements ChangeListener {

		/**
		 * 
		 */
		private static final long serialVersionUID = 7664901490669192679L;

		private static final String PROB_AI_DUMP = "AI";

		private static final String PROB_TABLE_DUMP = "Probability Table";

		private static final String STRATEGY_DUMP = "Strategy";

		private static final String RULESET_CHOICE_DUMP = "Ruleset Choice";

		public DumpFrame() {
			this.setTitle("Dump Flags");
			this.setLayout(new GridLayout(4, 1));
			JToggleButton pAIDump = new JToggleButton(PROB_AI_DUMP);
			this.getContentPane().add(pAIDump);
			pAIDump.setSelected(TestingFlags.probAIDump_);
			pAIDump.addChangeListener(this);

			JToggleButton pTableDump = new JToggleButton(PROB_TABLE_DUMP);
			this.getContentPane().add(pTableDump);
			pTableDump.setSelected(TestingFlags.probTableDump_);
			pTableDump.addChangeListener(this);

			JToggleButton startDump = new JToggleButton(STRATEGY_DUMP);
			this.getContentPane().add(startDump);
			startDump.setSelected(TestingFlags.aiStrategyDump_);
			startDump.addChangeListener(this);

			JToggleButton choiceDump = new JToggleButton(RULESET_CHOICE_DUMP);
			this.getContentPane().add(choiceDump);
			choiceDump.setSelected(TestingFlags.ruleSetChoiceDump_);
			choiceDump.addChangeListener(this);
			
			this.setUndecorated(true);
			this.pack();
			/*this.setLocation(TestingFlagsPanel.this.getWidth(), TestingFlagsPanel.this
					.getY());
			*/
			this.setResizable(false);
			this.setAlwaysOnTop(true);
			
		}

		public void stateChanged(ChangeEvent arg0) {
			JToggleButton src = (JToggleButton) arg0.getSource();
			String name = src.getText();

			if (name.equals(PROB_AI_DUMP)) {
				TestingFlags.probAIDump_ = src.isSelected();
			}
			if (name.equals(PROB_TABLE_DUMP)) {
				TestingFlags.probTableDump_ = src.isSelected();
			}

			if (name.equals(STRATEGY_DUMP)) {
				TestingFlags.aiStrategyDump_ = src.isSelected();
				
			}

			if (name.equals(RULESET_CHOICE_DUMP)) {
				TestingFlags.ruleSetChoiceDump_ = src.isSelected();
			}
		}
	}
	private void addTitleBorder(String string) {
		Border b = BorderFactory.createLineBorder(Color.BLACK);
		
		Border titleB = BorderFactory.createTitledBorder(b,string);
		this.setBorder(titleB);
		
	}
}
